/////////////////////////////////////////////////////////////////////////////////////
//  Trabalho de Projeto e Anlise de Algoritmos                                    //
//  4 Perodo de Sistema de Informao - Centro de Ensino Superior de Juiz de Fora//                                   //
//  Professor: Gustavo                                                             //
//  Aluno:                                                                         //
//       Fabricio S Costa  http://fabriciojf.blogspot.com                          //
//                                                                                 //
//  A inteno desta aplicao  mostrar os movimentos                             //
//  de um grafo atravs de uma matriz de adjacncia                                //
/////////////////////////////////////////////////////////////////////////////////////

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, Spin, Grids, ExtCtrls;

type
  TfMatriz = class(TForm)
    btnSair: TBitBtn;
    Panel2: TPanel;
    imgVertice5: TImage;
    imgVertice4: TImage;
    imgVertice1: TImage;
    imgVertice6: TImage;
    imgVertice2: TImage;
    imgVertice3: TImage;
    img11: TImage;
    img55: TImage;
    img44: TImage;
    img66: TImage;
    img22: TImage;
    img33: TImage;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    btnRessetar: TBitBtn;
    imgSeta: TImage;
    img0: TImage;
    imgx: TImage;
    cbPausar: TCheckBox;
    cbAbortar: TCheckBox;
    imgCanvas: TImage;
    imgVerticeNormal: TImage;
    Panel4: TPanel;
    img1: TImage;
    img2: TImage;
    img3: TImage;
    img5: TImage;
    img6: TImage;
    img4: TImage;
    Panel1: TPanel;
    sg1: TStringGrid;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    spInicio: TSpinEdit;
    spFim: TSpinEdit;
    BitBtn1: TBitBtn;
    lb1: TListBox;
    cbMatrizes: TComboBox;
    Label1: TLabel;
    Panel5: TPanel;
    Label2: TLabel;
    procedure btnSairClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure sg1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure btnRessetarClick(Sender: TObject);
    procedure sg1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure cbMatrizesChange(Sender: TObject);
    procedure sg1DblClick(Sender: TObject);

  private
    { Private declarations }

    {procedure para limpar a stringGrid que em nosso modelo substitui a matriz}
    procedure ressetarGrade;
    {procedure responsvel por caminhar na matriz e mntar a representao em tela}
    procedure caminhar;
    {procedure responsvel por montar o grafo em um componente image atravs de canvas e envi-lo  tela}
    procedure montarGrafo;
    {procedure limpar o componente image que contm o grafo}
    procedure ressetarGrafo;
    {procedure responsvel por desenhar a reta no componente imagem
       levando em conta a nova coordenada na borda do arco}
    function DesenharReta(OCor: TColor; Origem, Destino: TPoint): tpoint;
    {procedure responsvel por desenhar a seta no componente imagem}
    procedure DesenharSeta(OCor: TColor; OLargura: Integer; Origem, Destino: TPoint);
    {marca o grfico na tela}
    procedure marcarVertice(coluna, linha: integer; cor: tcolor);
    {monta os grafos default}
    procedure grafoPadrao(col, row: integer);

  public
    { Public declarations }

  end;

var
  fMatriz: TfMatriz;

implementation

uses Math;

{$R *.dfm}


procedure TfMatriz.btnSairClick(Sender: TObject);
begin
   close;
end;


{procedure para limpar a stringGrid que em nosso modelo substitui a matriz}
procedure TfMatriz.ressetarGrade;
var
   i, linha, coluna: integer;
begin

   {monta o comprimento e altura de cada clulda da stringGrid}
   for i:= 0 to 5 do
   begin
      sg1.ColWidths[i]:= 40;     // comprimento
      sg1.RowHeights[i]:= 40;    // altura
   end;

   {resseta a matriz colocando todos os campos com o valor 0}
   for coluna:= 0 to 5 do
      for linha:= 0 to 5 do
         sg1.Cells[coluna, linha]:= '0';

   {resseta o grafo na tela}
   ressetarGrafo;

end;


{procedure responsvel por caminhar na matriz e mntar a representao em tela}
procedure TfMatriz.caminhar;
var
   i, linha, coluna, qtdeItens: integer;
begin

   {todas as referncias na grade so feitas com o valor -1 por que a grade comea do 0}
   linha:= spInicio.Value - 1; // pega a linha inicial - aquela escolhida pelo usurio
   {resseta a coluna}
   coluna:= 0;
   {adiciona a sada do grafo no componente que substitui o vetor caminho}
   lb1.Items.Add(intToStr(linha + 1));

   {faz o loop mais importante do sistema
         passa pelo caminho de acordo com a matriz de adjacncia}
   while linha <= 5 do   {referente a linha}
   begin
      while coluna <= 5 do   {referente a coluna}
      begin

         {d ao usurio a possibilidade de pausar o processo}
         if cbPausar.Checked then
         begin
            messageDlg('Processo pausado ... Clique aqui para continuar a execuo ...', mtInformation, [mbOk], 0);
            cbPausar.Checked:= false;
         end;

         {d ao usurio a possibilidade de parar o processo}
         if cbAbortar.Checked then
         begin
            messageDlg('Processo abortado ...', mtInformation, [mbOk], 0);
            abort;
         end;

         {caso o valo da clula seja 1 passa o valor da coluna para a linha}
         if sg1.Cells[coluna, linha] = '1' then
         begin

            {marca o x no campo - somente cosmtica}
            sg1.Cells[coluna, linha]:= 'X';

            {acrescenta a nova linha ao vetor caminho}
            lb1.Items.Add(intToStr(coluna + 1));

            {passa o valor da coluna para a linha}
            linha:= coluna;

            {caso o valor da linha seja o vrtice final sai do loop}
            if linha = spFim.Value - 1 then
               exit;

            {d um refresh na tela - pausa alguns segundos e sai do loop mais interno}
            Application.ProcessMessages;
            sleep(500);
            break;

         end
         else
         begin
            {tratamento cosmtico - esse smbolo na procedure drawCell  substitudo pela imagem da seta}
            sg1.Cells[coluna, linha]:= '->';

            {d um refresh na tela - pausa alguns segundos}
            Application.ProcessMessages;
            sleep(500);

            {passa o valor 0 para a clula percorrida}
            sg1.Cells[coluna, linha]:= '0';
         end;

         {caso seja a ltima coluna resseta a coluna}
         if coluna = 5 then
         begin

            {caso seja o ltimo tem do vetor caminho informa que no tem caminho}
            if lb1.Items.Count -1 = 0 then
            begin
               messageDlg('No existe caminho para a vrtice ' + intToStr(spFim.value) +
                            ' partindo da vrtice ' + intToStr(spInicio.value), mtinformation, [mbOk], 0);
               abort;
            end;

            {deleta o ltimo tem do vetor caminho}
            lb1.Items.Delete(lb1.Items.Count -1);
            linha:= strToInt(lb1.Items[lb1.Items.Count -1]) - 1;

            {sa do loop mais interno}
            break;
         end
         else
            {incrementa a varivel coluna}
            inc(coluna);
      end;

      {resseta a varivel coluna}
      coluna:= 0;
   end;
end;

procedure TfMatriz.FormCreate(Sender: TObject);
begin
   {resseta o grafo na tela}
   ressetarGrade;
end;

procedure TfMatriz.marcarVertice(coluna, linha: integer; cor: tcolor);
var
   pi1, pi2, pf1, pf2: integer;
   npxy: tpoint;
begin

   {pega as coordenadas (pt.x, pt.y) da imagem selecionada na matriz}
   if coluna = 0 then
   begin
      pi1:= imgVertice1.left;
      pi2:= imgVertice1.top;
   end
   else if coluna = 1 then
   begin
      pi1:= imgVertice2.left;
      pi2:= imgVertice2.top;
   end
   else if coluna = 2 then
   begin
      pi1:= imgVertice3.left;
      pi2:= imgVertice3.top;
   end
   else if coluna = 3 then
   begin
      pi1:= imgVertice4.left;
      pi2:= imgVertice4.top;
   end
   else if coluna = 4 then
   begin
      pi1:= imgVertice5.left;
      pi2:= imgVertice5.top;
   end
   else if coluna = 5 then
   begin
      pi1:= imgVertice6.left;
      pi2:= imgVertice6.top;
   end; 

   if linha = 0 then
   begin
      pf1:= imgVertice1.left;
      pf2:= imgVertice1.top;
   end
   else if linha = 1 then
   begin
      pf1:= imgVertice2.left;
      pf2:= imgVertice2.top;
   end
   else if linha = 2 then
   begin
      pf1:= imgVertice3.left;
      pf2:= imgVertice3.top;
   end
   else if linha = 3 then
   begin
      pf1:= imgVertice4.left;
      pf2:= imgVertice4.top;
   end
   else if linha = 4 then
   begin
      pf1:= imgVertice5.left;
      pf2:= imgVertice5.top;
   end
   else if linha = 5 then
   begin
      pf1:= imgVertice6.left;
      pf2:= imgVertice6.top;
   end;

   {caso a linha seja diferente da coluna monta a linha no canvas com a seta}
   if linha <> coluna then
   begin
      {muda a cor da caneta}
      imgCanvas.Canvas.Pen.Color := cor;

      {a nova coordenada  na borda do arco}
      npxy:= DesenharReta(cor, point(pi1 + 16, pi2 + 16), point(pf1 + 16, pf2 + 16));

      {desenha a seta na tela}
      DesenharSeta(cor, 2, point(pi1 + 16, pi2 + 16), point(npxy.X, npxy.Y));
   end;
end;

procedure TfMatriz.BitBtn1Click(Sender: TObject);
begin
   {limpa o vetor caminho e caminha na matriz}
   lb1.Clear;
   caminhar;
end;

procedure TfMatriz.sg1SetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
   {monta o grafo na tela}
   montarGrafo;
end;


{procedure responsvel por montar o grafo em um componente image atravs de canvas e envi-lo  tela}
procedure TfMatriz.montarGrafo;
var
   visivel: boolean;
   cor: tcolor;
begin

   {se o valor do campo for 0 monta uma reta branca no lugar da reta existente
        ou torna a imagem self loop invisvel ou visvel}
   if sg1.Cells[sg1.col, sg1.Row] = '0' then
   begin
      visivel:= false;
      marcarVertice(sg1.Row, sg1.col, clWhite);
   end
   else
   begin
      visivel:= true;

      {marca a reta azul ou vermelha na tela}
      if (sg1.Row mod 2) = 0 then
         cor:= clred
      else
         cor:= $00FF5555;

      marcarVertice(sg1.Row, sg1.col, cor);
   end;

   if (sg1.Col = 0) and (sg1.Row = 0) then
      img11.Visible:= visivel

   else if (sg1.Col = 1) and (sg1.Row = 1) then
      img22.Visible:= visivel

   else if (sg1.Col = 2) and (sg1.Row = 2) then
      img33.Visible:= visivel

   else if (sg1.Col = 3) and (sg1.Row = 3) then
      img44.Visible:= visivel

   else if (sg1.Col = 4) and (sg1.Row = 4) then
      img55.Visible:= visivel

   else if (sg1.Col = 5) and (sg1.Row = 5) then
      img66.Visible:= visivel;

end;



procedure TfMatriz.btnRessetarClick(Sender: TObject);
var
   linha, coluna: integer;
begin
   {resseta a matriz (stringgrid)}
   ressetarGrade;

   {limpa a imagem usada para canvas}
   imgCanvas.Canvas.Brush.Color := clWhite;
   imgCanvas.Canvas.pen.Color := clWhite;
   imgCanvas.Canvas.Rectangle(0, 0, imgCanvas.Width, imgCanvas.Height);
end;


{procedure limpar o componente image que contm o grafo}
procedure TfMatriz.ressetarGrafo;
begin
   {torna as imagens self loop invisvel} 
   img11.Visible:= false;
   img22.Visible:= false;
   img33.Visible:= false;
   img44.Visible:= false;
   img55.Visible:= false;
   img66.Visible:= false;
end;


procedure TfMatriz.sg1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
   ptr: pointer;
   r: trect;
begin

   {ajusta o ponteiro}
   ptr:= sg1.Objects[aCol, aRow];
   sg1.Canvas.Font.Color:= LongInt(ptr);
   sg1.Canvas.TextRect(Rect, Rect.Left + 3, Rect.Top + 2, sg1.Cells[acol,arow]);

   {define as cores para as clulas}
   if gdfixed in state then
      sg1.Canvas.Brush.color:= clblack;

   {muda a cor da clula selecionada}
   if gdSelected in state then
   begin
      sg1.Canvas.Brush.Color:= clyellow;
      sg1.Canvas.Font.Color:= clyellow;
   end;

   {substitui o simbolo -> pela imagem seta}
   if (sg1.Cells[acol, arow] = '->') then
      sg1.Canvas.Draw(rect.Left, Rect.Top, imgSeta.Picture.Graphic);

   {substitui o simbolo 0 pela imagem 0}
   if (sg1.Cells[acol, arow] = '0') then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img0.Picture.Graphic)

   {substitui o simbolo 1 pela imagem 1}
   else if (sg1.Cells[acol, arow] = '1') then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img1.Picture.Graphic)

   {substitui o simbolo X pela imagem X}
   else if (sg1.Cells[acol, arow] = 'X') then
      sg1.Canvas.Draw(rect.Left, Rect.Top, imgx.Picture.Graphic);

end;


{procedure responsvel por desenhar a seta no componente imagem}
procedure tfMatriz.DesenharSeta(OCor: TColor; OLargura: Integer; Origem, Destino: TPoint);
const
   ANGULO = 30;
   PONTA  = 15;
   raio   = 5;
var
   AlphaRota, Alpha, Beta       : Extended;
   vertice1, vertice2, vertice3 : TPoint;
   novox, novoy: single;
begin

   {ponta da seta}
   imgCanvas.Canvas.Pen.Color   := OCor;
   imgCanvas.Canvas.Brush.Color := OCor;

   {calcula os pontos para a seta na ponta da reta}
   if (Destino.X >= Origem.X) then
   begin

      if (Destino.Y >= Origem.Y) then
      begin

         AlphaRota := Destino.X - Origem.X;

         if (AlphaRota <> 0) then
            Alpha := ArcTan((Destino.Y - Origem.Y) / AlphaRota)
         else
            Alpha := ArcTan(Destino.Y - Origem.Y);

         Beta := (ANGULO * (PI / 180)) / 2;
         vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
         vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
         vertice2.X := Round(vertice1.X - PONTA * Cos(Alpha + Beta));
         vertice2.Y := Round(vertice1.Y - PONTA * Sin(Alpha + Beta));
         vertice3.X := Round(vertice1.X - PONTA * Cos(Alpha - Beta));
         vertice3.Y := Round(vertice1.Y - PONTA * Sin(Alpha - Beta));
         imgCanvas.Canvas.Polygon([vertice1,vertice2,vertice3]);
      end
      else
      begin

         AlphaRota := Destino.Y - Origem.Y;
         if (AlphaRota <> 0) then
            Alpha := ArcTan((Destino.X - Origem.X) / AlphaRota)
         else Alpha := ArcTan(Destino.X - Origem.X);

         Beta := (ANGULO * (PI / 180)) / 2;
         vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
         vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
         vertice2.X := Round(vertice1.X + PONTA * Sin(Alpha + Beta));
         vertice2.Y := Round(vertice1.Y + PONTA * Cos(Alpha + Beta));
         vertice3.X := Round(vertice1.X + PONTA * Sin(Alpha - Beta));
         vertice3.Y := Round(vertice1.Y + PONTA * Cos(Alpha - Beta));
         imgCanvas.Canvas.Polygon([vertice1,vertice2,vertice3]);

      end;
   end
   else
   begin

      Alpha := ArcTan((Destino.Y - Origem.Y) / (Destino.X - Origem.X));
      Beta := (ANGULO * (PI / 180)) / 2;
      vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
      vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
      vertice2.X := Round(vertice1.X + PONTA * Cos(Alpha + Beta));
      vertice2.Y := Round(vertice1.Y + PONTA * Sin(Alpha + Beta));
      vertice3.X := Round(vertice1.X + PONTA * Cos(Alpha - Beta));
      vertice3.Y := Round(vertice1.Y + PONTA * Sin(Alpha - Beta));
      imgCanvas.Canvas.Polygon([vertice1,vertice2,vertice3]);
   end;
end;


{procedure responsvel por desenhar a reta no componente imagem
       levando em conta a nova coordenada na borda do arco}
function tfMatriz.DesenharReta(OCor: TColor; Origem, Destino: TPoint): tpoint;
const
   ANGULO = 30;
   PONTA  = 20;
   raio   = 5;
var
   AlphaRota, Alpha, Beta       : Extended;
   vertice1, vertice2, vertice3 : TPoint;
   novox, novoy: single;
begin

   {ponta da seta}
   imgCanvas.Canvas.Pen.Color   := OCor;
   imgCanvas.Canvas.Brush.Color := OCor;

   {usa o mesmo processo acima para calcular as novas coodenadas para a ponta da reta}
   if (Destino.X >= Origem.X) then
   begin

      if (Destino.Y >= Origem.Y) then
      begin

         AlphaRota := Destino.X - Origem.X;

         if (AlphaRota <> 0) then
            Alpha := ArcTan((Destino.Y - Origem.Y) / AlphaRota)
         else
            Alpha := ArcTan(Destino.Y - Origem.Y);

         Beta := (ANGULO * (PI / 180)) / 2;
         vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
         vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
         vertice2.X := Round(vertice1.X - PONTA * Cos(Alpha + Beta));
         vertice2.Y := Round(vertice1.Y - PONTA * Sin(Alpha + Beta));
         vertice3.X := Round(vertice1.X + PONTA * Cos(Alpha - Beta));
         vertice3.Y := Round(vertice1.Y + PONTA * Sin(Alpha - Beta));

         imgCanvas.Canvas.Polyline([Origem,vertice2]);
      end
      else
      begin

         AlphaRota := Destino.Y - Origem.Y;
         if (AlphaRota <> 0) then
            Alpha := ArcTan((Destino.X - Origem.X) / AlphaRota)
         else Alpha := ArcTan(Destino.X - Origem.X);

         Beta := (ANGULO * (PI / 180)) / 2;
         vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
         vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
         vertice2.X := Round(vertice1.X + PONTA * Sin(Alpha + Beta));
         vertice2.Y := Round(vertice1.Y + PONTA * Cos(Alpha + Beta));
         vertice3.X := Round(vertice1.X + PONTA * Cos(Alpha - Beta));
         vertice3.Y := Round(vertice1.Y + PONTA * Sin(Alpha - Beta));

         imgCanvas.Canvas.Polyline([Origem, vertice2]);

      end;

      result:= vertice3;
   end
   else
   begin

      Alpha := ArcTan((Destino.Y - Origem.Y) / (Destino.X - Origem.X));
      Beta := (ANGULO * (PI / 180)) / 2;
      vertice1.X := Destino.X - Round(Cos(Alpha + Beta));
      vertice1.Y := Destino.Y - Round(Sin(Alpha - Beta));
      vertice2.X := Round(vertice1.X + PONTA * Cos(Alpha + Beta));
      vertice2.Y := Round(vertice1.Y + PONTA * Sin(Alpha + Beta));
      vertice3.X := Round(vertice1.X + PONTA * Cos(Alpha - Beta));
      vertice3.Y := Round(vertice1.Y + PONTA * Sin(Alpha - Beta));

      imgCanvas.Canvas.Polyline([Origem,vertice2]);

   end;

   {retorna as novas coordenadas para a ponta da reta}
   result:= vertice2;

end;


procedure TfMatriz.grafoPadrao(col, row: integer);
var
   cor: tcolor;
begin
   {marca a matriz}
   sg1.Cells[col, row]:= '1';

   {marca a reta azul ou vermelha na tela}
   if (row mod 2) = 0 then
      cor:= clred
   else
      cor:= $00FF5555;

   {monta a linha na tela}
   marcarVertice(row, col, cor);
end;


procedure TfMatriz.cbMatrizesChange(Sender: TObject);
begin

   {limpa a grade e o grafo e remonta de acordo com a opo selecionada}
   btnRessetarClick(nil);

   {chama a funo responsvel por montar a matriz na grade o grafo na tela}
   if cbMatrizes.ItemIndex = 0 then
   begin
      grafoPadrao(1, 0);
      grafoPadrao(4, 0);
      grafoPadrao(2, 1);
      grafoPadrao(4, 1);
      grafoPadrao(3, 2);
      grafoPadrao(0, 3);
      grafoPadrao(2, 3);
      grafoPadrao(1, 4);
      grafoPadrao(2, 4);
      grafoPadrao(3, 4);
   end
   else if cbMatrizes.ItemIndex = 1 then
   begin
      grafoPadrao(1, 0);
      grafoPadrao(4, 0);
      grafoPadrao(2, 1);
      grafoPadrao(3, 1);
      grafoPadrao(4, 1);
      grafoPadrao(1, 2);
      grafoPadrao(2, 3);
      grafoPadrao(2, 4);
      grafoPadrao(3, 4);
   end;
end;

procedure TfMatriz.sg1DblClick(Sender: TObject);
begin
   if sg1.Cells[sg1.Col,sg1.row] = '1' then
      sg1.Cells[sg1.Col,sg1.row]:= '0'
   else
      sg1.Cells[sg1.Col,sg1.row]:= '1';

  {monta o grafo na tela}
   montarGrafo;
end;

end.
